<?php
// Upload multiple de fichiers avec barre de progression
// Blog Technophile tfrichet.fr
// Thibaud FRICHET - Mai 2013

// max upload 5Mo / 600 secondes
ini_set('memory_limit', '5000M');
ini_set('post_max_size', '5000M');
ini_set('upload_max_filesize', '5000M');
ini_set('max_execution_time', 600);
?>
<!DOCTYPE html>
<html>
    <head>
       
		<title>Upload multiple de fichiers avec barre de progression</title>
		<!-- JS : jquery, bootstrap, et XHR pour l'ajax -->
		<script type='text/javascript' src='jquery-1.9.1.min.js'></script>
		<script type='text/javascript' src='bootstrap/js/bootstrap.min.js'></script>
		<script type='text/javascript' src='XHR.js'></script>
		<!-- CSS : bootstrap -->
		<link href="bootstrap/css/bootstrap.min.css" rel="stylesheet" media="screen">
		<style>
			.form_inactif { display : none; } /* les forms ne sont pas affichés par défaut */
		</style>
		<script type='text/javascript'>
			// fonction appelée lorsque la page est chargée
			// appelle la fonction ajouter_form()
			$(document).ready(function()
			{
				ajouter_form();
			});
			
			// si il reste des forms non affichés, affiche le premier form
			// si il n'y a plus de forms à afficher, on cache le bouton
			function ajouter_form()
			{
				$('.form_inactif:first').removeClass('form_inactif').addClass('form_actif');
				
				if ($('.form_inactif').length == 0)
				{
					$('#btn_ajouter_form').hide();
				}
			}
			
			// Submit tout les forms à la suite
			function submit_forms()
			{
				if($('.form_actif').length > 0)
				{
					$('.form_actif:first').each(function()
					{
						$(this).removeClass('form_actif');
						$(this).submit();
					});
				}
				else
				{
					alert('Fini !');
				}
			}
			
			// appel ajax de la page ajax_apc_infos.php
			function upload_maj_apc(id_upload)
			{
				fichier = 'ajax_apc_infos.php?id_upload='+id_upload;
				zone = 'div_ajax_apc_'+id_upload;
				chargeFichier(fichier, zone, "POST", 'upload_after_ajax("'+id_upload+'");');
			}
			
			// récupère les infos de l'appel ajax de ajax_apc_infos.php
			// deux données sont stockées dans des input : la taille totale du fichier et la taille partielle uploadée
			// mets à jour la barre de progression
			// si l'upload est terminé, on passe au suivant
			function upload_after_ajax(id_upload)
			{
				var contentframe = $('#iframe_upload_'+id_upload).contents().text();
				
				var taille_totale = $('#total_'+id_upload).val();
				var taille_current = $('#current_'+id_upload).val();
				var progressbar = Math.floor(taille_current * 100 / taille_totale);
				if (progressbar < 5) { progressbar = 5; }
				
				if (contentframe == "1")
				{
					$('#upload_fini_'+id_upload).show();
					$('#progress_bar_'+id_upload).width('100%');
					
					submit_forms();
				}
				else
				{
					$('#progress_'+id_upload).show();
					$('#progress_bar_'+id_upload).width(progressbar+'%');
					window.setTimeout("upload_maj_apc('"+id_upload+"')", 500);
				}
			}		
		</script>
    </head>
    <body>
		<h1><a href='http://blog.tfrichet.fr/upload-multiple-de-fichiers-avec-barre-de-progression'>Upload multiple de fichiers avec barre de progression</a></h1>
		<h2><a href='http://blog.tfrichet.fr/'>Blog Technophile tfrichet.fr</a></h2>
		<h5><a href='http://blog.tfrichet.fr/a-propos/'>Thibaud FRICHET - Mai 2013</a></h5>
		
		<hr />
		
		<?php
		// Création de 5 forms inactifs
		// Chaque formulaire est identifié par un uniqid(), nécessaire pour APC
		for($i=1;$i<=5;$i++)
		{
			
			$id_upload = uniqid();
			?>

			<form class='form_inactif' id='form_upload_<?php echo $id_upload; ?>' style='margin-top:20px;padding:0px;' enctype="multipart/form-data" method="post" action="traitement.php" onsubmit="upload_maj_apc('<?php echo $id_upload; ?>');" target="iframe_upload_<?php echo $id_upload; ?>">
				<input type="hidden" id="id_upload" name="APC_UPLOAD_PROGRESS" value="<?php echo $id_upload; ?>" />
				<strong>Choisissez un fichier (5Mo max.)</strong><br />
				<input type='file' name='fichier_<?php echo $id_upload; ?>' id='fichier_<?php echo $id_upload; ?>' />
				<div class="progress progress-success progress-striped" style='width:200px;height:20px;' id='progress_<?php echo $id_upload; ?>'>
				  <div class="bar" style="width:0%;" id='progress_bar_<?php echo $id_upload; ?>'></div>
				</div>

				<img src='ok.png' id='upload_fini_<?php echo $id_upload; ?>' style='float:left;margin-left:10px;display:none;' />

				<br />
			
			</form>
			<iframe id="iframe_upload_<?php echo $id_upload; ?>" name="iframe_upload_<?php echo $id_upload; ?>" src="traitement.php" style='display:none;'></iframe>
			<div id="div_ajax_apc_<?php echo $id_upload; ?>" style='display:none;'></div>
			<?php
		}
		?>
		
		<button id='btn_ajouter_form' class='btn' onclick='ajouter_form();'>Ajouter un fichier</button>
		<button class='btn btn-primary' onclick='submit_forms();'>Envoyer les fichiers</button>
   </body>
</html>